/* 
 * File:   main.c
 * Author: User
 *
 * Created on 04 July 2014, 12:18
 */


#ifndef __PICCPRO__              //http://www.microchip.com/forums/m780759.aspx
#define __PICCPRO__
#endif

// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG1
#pragma config FOSC = XT        // Oscillator Selection (XT Oscillator, Crystal/resonator connected between OSC1 and OSC2 pins)
#pragma config WDTE = OFF       // Watchdog Timer Enable (WDT disabled)
#pragma config PWRTE = ON       // Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON       // MCLR Pin Function Select (MCLR/VPP pin function is MCLR)
#pragma config CP = OFF         // Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF        // Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = OFF      // Brown-out Reset Enable (Brown-out Reset disabled)
#pragma config CLKOUTEN = ON    // Clock Out Enable (CLKOUT function is enabled on the CLKOUT pin)
#pragma config IESO = OFF       // Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF        // Flash Memory Self-Write Protection (Write protection off)
#pragma config PLLEN = OFF      // PLL Enable (4x PLL disabled)
#pragma config STVREN = OFF     // Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will not cause a Reset)
#pragma config BORV = HI        // Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), high trip point selected.)
#pragma config LVP = OFF        // Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)




#include <stdio.h>
#include <stdlib.h>
#include <xc.h>
#include <PIC16F1827.h>
#include "usart.h"
#include "lcd.h"
#include "i2c.h"



#define _XTAL_FREQ  4000000

void init_pic(void)
{
	//OSCCON = 0b01101000;
	PORTA = 0x00;
	PORTB = 0x00;
	ANSELA = 0x00;
	ANSELB = 0b00001000; //analogue input on AN9 (RB3)
	TRISA=0b00000000;
	TRISB=0b00111110;	//set up for I2C and USART, plus ADC input on AN9 (RB3)
}


int main(int argc, char** argv)

{

	unsigned char input;
	unsigned char c = 0;

	INTCON=0;	//  disable interrupts.

	init_pic();

	init_comms();	// set up the USART - settings defined in usart.h

	lcd_init();
	lcd_goto(0);  // select first line

	lcd_puts("UART test");
	lcd_goto(0x40);	// Select second line
	lcd_puts("program");
	__delay_ms(1000);
	lcd_clear();

	// Output a message to prompt the user for a keypress
	printf("\rChracters entered will be displayed on the LCD\n");


while(1){
		input = getch();	// read a response from the serail port
		{
			lcd_putch(input); //pass to the display
			c++;				//increment the position counter

			if (c == 16)
			{
				lcd_goto(0x40);	// Select second line
			}

			if (c == 33)	//one past the end of the second line
			{
				lcd_clear(); //clear the display ready for the next charcter
				c = 0;
				lcd_putch(input);
			}
		}

	}



    return (EXIT_SUCCESS);
}
